/*!
 * @file        main.c
 *
 * @brief       Main program body
 *
 * @version     V1.0.1
 *
 * @date        2025-04-31
 *
 * @attention
 *
 *  Copyright (C) 2026 Geehy Semiconductor
 *
 *  You may not use this file except in compliance with the
 *  GEEHY COPYRIGHT NOTICE (Geehy Semiconductor Software License Agreement).
 *
 *  The program is only for reference, which is distributed in the hope
 *  that it will be useful and instructional for customers to develop
 *  their software. Unless required by applicable law or agreed to in
 *  writing, the program is distributed on an "AS IS" BASIS, WITHOUT
 *  ANY WARRANTY OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the Geehy Semiconductor Software License Agreement for the governing permissions
 *  and limitations under the License.
 */

#define PORT_ENABLE

/* Includes */
#include "stdio.h"

#include "Port.h"
#include "CDD_Usart.h"
#include "Mcu.h"
#include "Adc.h"

#include "CDD_Pdl.h"
/** @addtogroup Examples
  @{
  */

/** @defgroup Template_Macros Macros
  @{
*/

/**@} end of group Template_Macros */

/** @defgroup Template_Enumerations Enumerations
  @{
*/

/**@} end of group Template_Enumerations */

/** @defgroup Template_Structures Structures
  @{
*/

/**@} end of group Template_Structures */

/** @defgroup Template_Variables Variables
  @{
*/
/**@} end of group Template_Variables */

/** @defgroup Template_Functions Functions
  @{
  */

void delay(volatile uint32 value)
{
    while(value--);
}


Adc_ValueGroupType ResultBufferGroup0[ADC_CONFIG_GROUP0_CHANNEL_NUM * ADC_GROUP0_NUMBER_OF_SAMPLES];

/*!
 * @brief       Main program
 *
 * @param       None
 *
 * @retval      None
 *
 * @note
 */
int main(void)
{
    Mcu_Init(&g_mcuConfig);
    Mcu_InitClock(McuClockSettingConfig_0);
    Port_Init(&g_portConfig);
    Usart_Init(g_usartConfg);
    Pdl_Init(&g_pdlConfig);
    Adc_Init(&g_adcConfig);
    
    Adc_SetupResultBuffer(ADC_GROUP_0,ResultBufferGroup0);
    Adc_StartGroupConversion(ADC_GROUP_0);
    delay(1000);
    Adc_StopGroupConversion(ADC_GROUP_0);
    
    printf("group0 = %dmV %dmV %dmV\r\n",(ResultBufferGroup0[0]* 3300) / 4095,
                                         (ResultBufferGroup0[1]* 3300) / 4095,
                                         (ResultBufferGroup0[2]* 3300) / 4095);
    while (1)
    {
        
    }
}

#if defined (__CC_ARM) || defined (__ICCARM__) || (defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050))

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @param       *f:  pointer to a FILE that can recording all information
*              needed to control a stream
*
* @retval      The characters that need to be send.
*
* @note
*/
int fputc(int ch, FILE* f)
{
    int reVal = 0;
    reVal = Usart_PutRedefinition(USART1_ID,&ch);
    
    return reVal;
}

/* If configuring the full library using versions after IAR 9.30,
   it is necessary to implement the _write function for printf redirection.*/
size_t __write(int handle,const unsigned char *buf,size_t bufSize)
{
    int32 tempCh = 0;
    for(int i=0; i<bufSize; i++)
    {
        Usart_PutRedefinition(USART1_ID,&tempCh);
    }
    return bufSize;
}

#elif defined (__GNUC__)

/* For Arm Cross GCC: Eclipse */
int _write(int fd,const unsigned char *buf,int len)
{
    int32 tempCh = 0;
    for(int i=0; i<len; i++)
    {
        int32 tempCh = (int32)buf[i];
        Usart_PutRedefinition(USART1_ID,&tempCh);
    }
    return len;
}

#endif
/**@} end of group Template_Functions */
/**@} end of group Template */
/**@} end of group Examples */
